/*
 * You received this file as part of
 * FlexRay4Linux - FlexRay protocol stack for Linux
 * 
 * This file contains:
 *
 * - Protoypes and definitions for FlexRay protocol modules using the
 *   PF_FLEXRAY core
 *
 * Copyright:
 * 
 * - (C) 2009-2011 Michael Arndt <flexray4linux@scriptkiller.de>,
 *   Robotics Research Lab, University of Kaiserslautern
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY RIGHTS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER(S) AND AUTHOR(S) BE LIABLE FOR ANY
 * CLAIM, OR ANY SPECIAL INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * ALL LIABILITY, INCLUDING LIABILITY FOR INFRINGEMENT OF ANY PATENTS,
 * COPYRIGHTS, TRADEMARKS OR OTHER RIGHTS, RELATING TO USE OF THIS
 * SOFTWARE IS DISCLAIMED.
 *
 * The provided data structures and external interfaces from this code
 * are not restricted to be used by modules with a GPL compatible license.
 * 
 */

#ifndef __AF_FLEXRAY_H__
#define __AF_FLEXRAY_H__

/**
 * FlexRay protocol structure
 */
struct fr_proto {
	/** type argument in socket() syscall, e.g. SOCK_RAW */
	int type;
	/** protocol number in socket() syscall */
	int protocol;
	/** capability needed to open the socket, or -1 for no restriction */
	int capability;
	/** pointer to struct proto_ops for sock->ops */
	struct proto_ops *ops;
	/** pointer to struct proto structure */
	struct proto     *prot;
};

/* prototypes */

extern int  fr_proto_register(struct fr_proto *cp);
extern void fr_proto_unregister(struct fr_proto *cp);
extern int fr_send(struct sk_buff *skb);
int fr_rx_register(struct sock *sk);
int fr_rx_unregister(struct sock *sk);

#endif
